# !/usr/bin/perl
# OLEX / GOOGLE EARTH CONVERSION
# powered by Albin Evanno <all_evanno@hotmail.fr>

#---------------------------------------------------------------------------------------------------------------

# for use with Windows (peio = user's name)
#$pathIN = "C:\\Documents and Settings\\peio\\Desktop\\Ruter.txt";
#$pathOUT = "C:\\Documents and Settings\\Peio\\Desktop\\Ruter.kml";

#---------------------------------------------------------------------------------------------------------------

# for use with MacOSX  (peio = user's name)
$pathIN = "/Users/peio/Desktop/Olex/Ruter.txt" ;
$pathOUT = "/Users/peio/Desktop/Olex/Ruter.kml";

#---------------------------------------------------------------------------------------------------------------

 @TabFolder = ();
 @TabChiffre = ([512,"J"],[256,"I"],[128,"H"],[64,"G"],[32,"F"],[16,"E"],[8,"D"],[4,"C"],[2,"B"],[1,"A"]);

 $nbfiles=0;
 $i=0;
 $j=0;
 
sub FOpenIn { open (IN, "<$pathIN") or die "A problem occurred during the opening of the file !\n"; }  
sub FOpenOut { open (OUT, ">$pathOUT") or die "A problem occurred during the creation of the file !\n"; }  

print "Conversion start\n";
 
 sub FBeginKml {print OUT "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
                print OUT "<kml xmlns=\"http://earth.google.com/kml/2.0\">\n";
                print OUT "<Document>\n";
                print OUT "<name>OLEX user data</name>\n";
                print OUT "<description>\n";
                print OUT "<![CDATA[\n";
                print OUT "powered by <a href='www.justmagic.com'>Magic Instinct Software</a><br>]]>\n";
                print OUT "</description>\n";
               }  

 sub FColor { $res = $_[0];
              
              if ($res eq "") { return "f2ffff86" }  
              elsif ($res eq "Rod") { return "ff000fff" }  
              elsif ($res eq "Gul") { return "ff08c5f4" }  
              elsif ($res eq "Gronn") { return "7f00ff00" }  
              elsif ($res eq "Lilla") { return "ffdd0fcc" }  
              elsif ($res eq "Brun") { return "ff145796" }  
              elsif ($res eq "Svart") { return "ff000000" }  
            }  
            
 sub FCode { $code = $_[0];
             
             if ($code eq "Sprsml") {return " Sporsmal" }  
             elsif ($code eq "Rdramme") { return "Rodramme" }  
             elsif ($code eq "Rdpyramide") { return "Rodpyramide" }  
             elsif ($code eq "Grnnramme") { return "Gronnramme" }  
             elsif ($code eq "Grnnkryss") { return "Gronnkryss" }  
             elsif ($code eq "Grnnpyramide") { return "Gronnpyramide" }  
             elsif ($code eq "Blramme") { return "Blaramme" }  
             elsif ($code eq "Blkryss") { return "Blakryss" }  
             else { return $code }  
           }  
           
 sub FType { $Type = $_[0];
 
             if ($Type eq "") { return "Route" }  
             elsif ($Type eq "Strek") { return "Track" }  
             elsif ($Type eq "Linje") { return "Line" }  
           }  
           
 sub FTabFolder1 { while ($line = <IN>)
                         { chomp $line;
                           if ($line =~ /Plottsett /)
                              { $numSurface = $';
                              while (($numSurface != $TabFolder[$nbfiles])&&($nbfiles != (scalar(@TabFolder))))
                                    {$nbfiles++; } 
                                     if ($nbfiles == (scalar(@TabFolder)))
                                        {$TabFolder[$nbfiles]=$numSurface; } 
                                     $nbfiles=0;
                              }  
                         }  
                   $nbElTabFolder = scalar(@TabFolder);
                   close IN;
                 }  
 
 sub FTabFolder2 { for ($folder=0; $folder<=($nbElTabFolder-1); $folder++)
                       { $chiffre=0;
                         $fol=1;
                         $var1= $TabFolder[$folder];
                         $res = ($var1/$TabChiffre[$chiffre][0]);
                         $TabFolder[$folder][0]= $TabFolder[$folder];
                         while ($res != 1)
                               {
                                if ($res =~ /^0./)
                                   { $chiffre++;
                                    $res = ($var1/$TabChiffre[$chiffre][0]) }  
                                else
                                    {
                                     $TabFolder[$folder][$fol]= $TabChiffre[$chiffre][1];
                                     $var1=($var1-$TabChiffre[$chiffre][0]);
                                     $chiffre++;
                                     $fol++;
                                     $res=$var1/$TabChiffre[$chiffre][0]; }  
                               }  
                         $TabFolder[$folder][$fol]= $TabChiffre[$chiffre][1];
                       }  
                 }  
                 
 sub FTab { while ($line = <IN>)
                 { chomp $line;

                   if ( $line =~ /Rute /)
                      { $name = $'; $Tab[$i][1] = $name;
                      if ( $name eq "uten navn" ) { $Tab[$i][1] = "noname"; } 
                      } 
                   elsif ($line =~ /Rutetype /)
                         { $type = $'; $Tab[$i][2] = $type; }  
                   elsif ($line =~ /Linjefarge /)
                         { $color = $'; $Tab[$i][3] = $color; }  
                   elsif ($line =~ /Plottsett /)
                         { $numSurface = $'; $Tab[$i][0] = $numSurface; } 
                   elsif (($line =~ /^\d/) || ($line =~ /Navn /) || ($line =~ /MTekst \d:/))
                         { 
                          if ($line =~ /^\d/)
                             { $Tab[$j][0] = $numSurface;
                               @TabCoor = split(/\s/,$line);
                               $coorLat = ($TabCoor[0]/60); $Tab[$j][4] = $coorLat;
                               $coorLong = ($TabCoor[1]/60); $Tab[$j][5] = $coorLong;
                               $unixHour = $TabCoor[2]; $Tab[$j][6] = $unixHour;
                               $icon = $TabCoor[3]; $Tab[$j][7] = $icon;
                               $j++;
                             }  
                          elsif ($line =~ /Navn /)
                             { $nameNavn = $'; $Tab[$j-1][8] = $nameNavn; }  

                          elsif ($line =~ /MTekst \d:/)
                             { $desc1 = $';
                              $desc2 = $desc2."\n".$desc1."<br>" ;
                              $Tab[$j-1][9] = $desc2; }  
                         }  

                    else { $i = $j; $desc2 = "" }  
                  }  
            $nbElTab = $j;
            close IN;
          }  

 sub FOpenFolder1 { if ($find==0)
                       { print OUT "<Folder>\n";
                        print OUT "<name>$letter</name>\n";
                        $find=1;
                       }  
                  }  

 sub FOpenFolder2 { if ($Tab[$n][1] ne "")
                      { print OUT "<Folder>\n";
                       print OUT "<name>$Tab[$n][1]</name>\n";
                      }  
                  }  

 sub FArea { if (($Tab[$n+1][1] eq "") && ($passage==0) && ($Tab[$n][2] eq "Areal"))
                { $passage=1;
                  print OUT "<Placemark>\n";
                    print OUT "<name>Zone</name>\n";
                       print OUT "<Style>\n";
                          print OUT "<PolyStyle>\n";
                          print OUT "<color>".FColor("$Tab[$n][3]")."</color>\n";
                          print OUT "</PolyStyle>\n";
                       print OUT "</Style>\n";
                    print OUT "<Polygon>\n";
                       print OUT "<tessellate>1</tessellate>\n";
                       print OUT "<outerBoundaryIs>\n";
                       print OUT "<LinearRing>\n";
                       print OUT "<coordinates>\n";
                          print OUT "$Tab[$n][5],$Tab[$n][4],0\n";
                                                    
                  $o=$n;
                  while (($Tab[$o+1][1] eq "") && ($o!=$nbElTab-1))
                        { print OUT "$Tab[$o+1][5],$Tab[$o+1][4],0\n";
                         $o++; } 
            
                       print OUT "</coordinates>\n";
                       print OUT "</LinearRing>\n";
                       print OUT "</outerBoundaryIs>\n";
                    print OUT "</Polygon>\n";
                  print OUT "</Placemark>\n";
                }  
           }  
           
 sub FLine { if (($Tab[$n+1][1] eq "") && ($passage==0) && ($Tab[$n][2] ne "Areal"))
                { $passage=1;
                  print OUT "<Placemark>\n";
                     print OUT "<name>".FType("$Tab[$n][2]")."</name>\n";
                     print OUT "<Style>\n";
                        print OUT "<LineStyle>\n";
                           print OUT "<color>".FColor("$Tab[$n][3]")."</color>\n";
                           print OUT "<width>2</width>\n";
                        print OUT "</LineStyle>\n";
                     print OUT "</Style>\n";
                     print OUT "<LineString>\n";
                        print OUT "<extrude>0</extrude>\n";
                        print OUT "<tessellate>1</tessellate>\n";
                        print OUT "<altitudeMode>relativeToGround</altitudeMode>\n";
                        print OUT "<coordinates>\n";
                           print OUT "$Tab[$n][5],$Tab[$n][4],0\n";

                  $o=$n;
                  while (($Tab[$o+1][1] eq "") && ($o!=$nbElTab-1))
                        { print OUT "$Tab[$o+1][5],$Tab[$o+1][4],0\n";
                         $o++;
                        }  
                         print OUT "</coordinates>\n";
                     print OUT "</LineString>\n";
                  print OUT "</Placemark>\n";
                }  
           }  
           
 sub FIconFolder { if ($icon==0)
                      { print OUT "<Folder>\n";
                       print OUT "<name>Icons</name>\n";
                       $icon=1;
                      }  
                 }  
                 
 sub FPlacemark { print OUT "<Placemark>\n";
                    print OUT "<name>$Tab[$n][8]</name>\n";
                    print OUT "<description>\n";
                    print OUT "<![CDATA[\n";
                       print OUT "$Tab[$n][9]<br>]]>\n";
                    print OUT "</description>\n";
                    print OUT "<Style>\n";
                       print OUT "<IconStyle>\n";
                          print OUT "<Icon>\n";
                             print OUT "<href>Olex_icons_alpha_canal/".FCode("$Tab[$n][7]").".png</href>\n";
                          print OUT "</Icon>\n";
                       print OUT "</IconStyle>\n";
                    print OUT "</Style>\n";
                    print OUT "<Point>\n";
                       print OUT "<coordinates>$Tab[$n][5],$Tab[$n][4],0</coordinates>\n";
                    print OUT "</Point>\n";
                  print OUT "</Placemark>\n";
                }  
                
 sub FCloseFolder2 { if (($Tab[$n+1][1] ne "") || ($n==$nbElTab-1))
                        { $passage=0;
                          $icon=0;
                          print OUT "</Folder>\n";
                          print OUT "</Folder>\n";
                        }  
                   }  
                   
 sub FCloseFolder1 { if ($find==1)
                        { print OUT "</Folder>\n"; } 
                   }  

 sub FWriteKml { $passage=0;
                 $icon=0;
                 for ($k=9; $k>=0; $k--)
                     { $find=0;
                       $letter=$TabChiffre[$k][1];
                       for ($l=0; $l<=($nbElTabFolder-1); $l++)
                           { $m=1;
                             while (($TabFolder[$l][$m] ne $letter) && ($TabFolder[$l][$m] ne ""))
                                   { $m++; } 
                             if ($letter eq ($TabFolder[$l][$m]))
                                { FOpenFolder1 ();
                                  for ($n=0; $n<=($nbElTab-1); $n++)
                                      { if ($TabFolder[$l][0] == $Tab[$n][0])
                                           { FOpenFolder2 ();
                                             FArea ();
                                             FLine ();
                                             FIconFolder ();
                                             FPlacemark ();
                                             FCloseFolder2 ();
                                           }  
                                      }  
                                }  
                           }  
                       FCloseFolder1 ();
                     }  
               }  

 sub FEndKml { print OUT "</Document>\n";
               print OUT "</kml>";
               close OUT;
             }  
             
 print "End conversion\n";

 ########################################
 #             Main Program             #
 ########################################
 
 FOpenIn ();
 FOpenOut ();
 FBeginKml ();
 FTabFolder1();
 FTabFolder2();
 FOpenIn ();
 FTab ();
 FWriteKml ();
 FEndKml ();